#include <iostream>
#include "List.h"


void main () {
	NodePtr node1, node2, node3, node4;
	node1 = NULL;
	node2 = new Node ("Hello!", node1);
	node3 = new Node ("Goodbye!", node2);
	node4 = new Node ("Yippee!", node3);

	List list1, list2(node2), list3(node3), list4(node4);

	cout << node2->getFirst() << " (should be Hello)" << endl;
	cout << node3->getFirst() << " (should be Goodbye)" << endl;
	NodePtr anotherNode = node3->getNext();
	cout << anotherNode->getFirst() << " (should be Hello)" << endl;

	cout << "list1.length() = " << list1.length() << endl;
	cout << "list2.length() = " << list2.length() << endl;
	cout << "list3.length() = " << list3.length() << endl;
	cout << "list4.length() = " << list4.length() << endl;
	cout << "list1.recursive_length() = " << list1.recursive_length() << endl;
	cout << "list2.recursive_length() = " << list2.recursive_length() << endl;
	cout << "list3.recursive_length() = " << list3.recursive_length() << endl;
	cout << "list4.recursive_length() = " << list4.recursive_length() << endl;

	cout << "list1.description() = " << list1.iterative_description() << endl;
	cout << "list2.description() = " << list2.iterative_description() << endl;
	cout << "list3.description() = " << list3.iterative_description() << endl;
	cout << "list4.description() = " << list4.iterative_description() << endl;

	list4.addToFront("new first element");
	cout << "After adding, list4 is " << list4.description() << endl;

	list4.addAtPosition("third",2);
	cout << "After adding third element, list4 is " << list4.description() << endl;
}
