// List.h: interface for the List class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIST_H__3CF52313_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
#define AFX_LIST_H__3CF52313_CD63_11D5_8592_00C04F2B1D70__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Node.h"

class List  
{
public:
	List();
	List(NodePtr h);
	virtual ~List();

	int length() const;
	int recursive_length() const;

	std::string description() const;
	std::string iterative_description() const;

	void addToFront(string s);
	void addAtPosition(string s, int where);

	void removeFirst();
	void removeAtPosition (int where);
private:
	NodePtr head;
};

// void addAfter (string s, NodePtr &currentNode);

#endif // !defined(AFX_LIST_H__3CF52313_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
