// Node.h: interface for the Node class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
#define AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>
using namespace std;

class Node  
{
private:
	string first;
	Node *next;
public:
	Node(string f, Node *r);
	Node(const Node &other);
	virtual ~Node();

// access methods
	string getFirst () const;

	Node *getNext () const;
//	void setNext (Node *newNext);

	void removeAtPosition (int where);
	void iterativeRemoveAtPosition (int where);
	void addAtPosition(string s, int where);
};

typedef Node *NodePtr;

void removeAfter (NodePtr &prev);
void addAfter (string s, NodePtr &prev);

#endif // !defined(AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
