// Node.cpp: implementation of the Node class.
//
//////////////////////////////////////////////////////////////////////

#include "Node.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Node::Node(string f, NodePtr r)
{
	first = f;
	next = r;
}

Node::~Node()
{

}

Node::Node (const Node &other)
{
	first = other.first;
	next = other.next;
}

string Node::getFirst () const
{
	return first;
}

NodePtr Node::getNext () const {
	return next;
}

