// Node.h: interface for the Node class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
#define AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>
using namespace std;
class Node;
typedef Node *NodePtr;

class Node  
{
private:
	string first;
	NodePtr next;
public:
	Node(string f, NodePtr r);
	Node(const Node &other);
	virtual ~Node();

// access methods
	string getFirst () const;

	NodePtr getNext () const;
	void setNext (NodePtr newNext);

};


#endif // !defined(AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
