#include <iostream>
#include "List.h"

string firstchar (string s)
{
	return s.substr(0,1);
}

string repeat (string s)
{
	return s + s;
}


void main () {

	List list1, list2, list3, list4;

	list2.addToFront ("Hello!");
	list3.addToFront ("Hello!");
	list3.addToFront ("Goodbye!");
	list4.addToFront ("Hello!");
	list4.addToFront ("Goodbye!");
	list4.addToFront ("Yippee!");

	cout << "list1.length() = " << list1.length() << endl;
	cout << "list2.length() = " << list2.length() << endl;
	cout << "list3.length() = " << list3.length() << endl;
	cout << "list4.length() = " << list4.length() << endl;
	cout << "list1.recursive_length() = " << list1.recursive_length() << endl;
	cout << "list2.recursive_length() = " << list2.recursive_length() << endl;
	cout << "list3.recursive_length() = " << list3.recursive_length() << endl;
	cout << "list4.recursive_length() = " << list4.recursive_length() << endl;

	cout << "list1.description() = " << list1.iterative_description() << endl;
	cout << "list2.description() = " << list2.iterative_description() << endl;
	cout << "list3.description() = " << list3.iterative_description() << endl;
	cout << "list4.description() = " << list4.iterative_description() << endl;

	list4.addToFront("new first element");
	cout << "After adding, list4 is " << list4.description() << endl;

	list4.addAtPosition("third",2);
	cout << "After adding third element, list4 is " << list4.description() << endl;

	list4.removeFirst();
	cout << "After removing first element, list4 is " << list4.description() << endl;

	list4.removeAtPosition(2);
	cout << "After removing third element, list4 is " << list4.description() << endl;

	cout << "First chars of list4: " << list4.map(firstchar)->description() << endl;

	cout << "Repetitions of list4: " << list4.map(repeat)->description() << endl;
// Note: the "map" method creates a new list, and we're never deleting it.
// This is a memory leak.  I'm not dealing with it right now because that's
// not the topic I'm trying to illustrate, but it should be dealt with.
}
